#include "Bands.h"

Bands::Bands(ReadInput * R, Stack * S)
{
  Input = R;
  St = S;
  pattern = new B_pattern[MaxN];
  memset(pattern, 0, MaxN*sizeof(B_pattern)); //to set all values of pattern to zero
  int i;
  for (i=1; i <= Input->Size; i++)
    {
      pattern[i].BandBorder = false;
      pattern[i].prev = i-1;
      pattern[i].next = i+1;
      pattern[i].OtherBorder = 0;
    }

  for (i=1; i<= Input->Size; i++) // we can integrate it into the program itself too
    if (Input->BasePair(i) <= 0)
      {
	Update_links (pattern[i].prev, pattern[i].next);
      }
};

Bands::~Bands()
{
  delete [] pattern;
};

void Bands::Output(int border1, int border2, int NumberOfBands)
{
  int i=border1;
  int k=0;
    
  while (i<border2+1)
    {
	  if(i < Input->BasePair(i))
	  {
	    
	    printf(" %d-%d and %d-%d   ", i, pattern[i].OtherBorder, Input->BasePair(pattern[i].OtherBorder), Input->BasePair(i));
	    /*
	    printf(" %d-%d and %d-%d   ",i,pattern[i].OtherBorder,Input->BasePair(pattern[i].OtherBorder),Input->BasePair(i));
	    */
	  }

      i = pattern[i].next;
    }
}

int Bands::Find_next_good_index (int i, int border1, int border2)
{
  while (  (pattern[i].BandBorder == true) && (i < border2+1))
    {
      //(pattern[i].bp == 0) ||  for integrating
      i = pattern[i].next;
    }
  return i;
}

void Bands::aux_Find_bands(int border1, int border2, int* NumberOfBands, int* CurrentBandRegion, vector <int>& bands_remove, vector <int>& bandborders)
{
  int i,j,i_prime,j_prime; // the band will be [i,i_prime] [j_prime,j]
  int i_help, j_help;
  i = Find_next_good_index(border1, border1, border2);
  //my code begin
  *NumberOfBands = 0;
  //my code end
  *CurrentBandRegion = 0;

  while ( i < border2+1)
    {
      //my code begin
      *NumberOfBands = *NumberOfBands+1 ;
      //my code end
      j= Input->BasePair(i);
      i_prime = i;       
      j_prime = j;

      while (true)
	{
	  i_help = pattern[i_prime].next;
	  j_help = pattern[j_prime].prev;
	  if (Input->BasePair(i_help) == j_help)
	    {
	      i_prime = i_help;
	      j_prime = j_help;
	    }
	  else
	    break;      
	}

      // now we have found i, i' j,j' and should update the list
      // but before that we want to coordinate the "to_be_removed" stuff
      
      //cout << "HELLO\nHere is our new band: " << i << "-" << i_prime << " " << j_prime << "-" << j << endl;
      
      if(Input->not_finished)
      {
      for(int p=0; p<Input->to_be_removed.size(); p++)
      {
      if(Input->to_be_removed[p]==i) //thus this band is not included in MIS according to our evaluation
      {
      //record the band, update where_at
      Input->bands_to_remove.push_back(i);
      Input->bands_to_remove.push_back(i_prime);
      Input->bands_to_remove.push_back(j_prime);
      Input->bands_to_remove.push_back(j);
      Input->where_at=p+(i_prime-i)+1;
      
      bands_remove.push_back(i);
      bands_remove.push_back(i_prime);
      bands_remove.push_back(j_prime);
      bands_remove.push_back(j);
      }
      if(Input->to_be_removed[p]>i) //this band is in our MIS for sure, and we dont' even need to loop to find that out :)
      {
      break;
      }
      }
      }

      //quickly update the bandborders
      bandborders.push_back(i);
      bandborders.push_back(i_prime);
      bandborders.push_back(j_prime);
      bandborders.push_back(j);  


      //back to updating the list...
      pattern[i].BandBorder = true;
      pattern[j_prime].BandBorder = true;
      pattern[i].OtherBorder = i_prime;
      pattern[j_prime].OtherBorder = j;

      // add new
      if (*CurrentBandRegion < j_prime)
	*CurrentBandRegion = j_prime;
      // add new

      if (i != i_prime)  // if the band is not just a base pair
	{
	  Update_links(i, pattern[i_prime].next);
	  Update_links(j_prime,pattern[j].next);
	}
      i = Find_next_good_index(pattern[i].next, border1, border2); fflush(stdout);
    }
  // now we have bands!!!
}

void Bands::Update_links(int from , int to)
{
  pattern[from].next = to;
  pattern[to].prev = from;
}

int Bands::Prev(int i)
{
  return pattern[i].prev;
};

int Bands::Next(int i)
{
  return pattern[i].next;
};



