#ifndef DEFINES_H
#define DEFINES_H

#include <stdio.h>
#include <stdlib.h>
#include <memory.h>
#include <assert.h>
#include <string.h>
#include <time.h>
#include <fstream>

//the following two were taken from Mirela's free code for energy calculation
#define MAX_BRANCHES    50           // maximum # of branches in multiloops
#define NONE            'N'
#define A               0
#define C               1
#define G               2
#define U               3
#define T               3

#define    BPSEQ        0
#define    DP           1 



//the following consts were already here or were added by Vera later on
const int MaxN = 5000; //max length of the strand (ie the size of Sequence array), used in Input.h
const int MaxNlength = 200; //this is the size of the length array, basically the number
                           //of branches a multi/external can have used in Loop.h
const char MotifFile[11] = "motifs.txt"; //the name of the file that is being used for hairpin motif
                                         //characterization (should be in LE folder)
const int MAXLINE=5000; //used in main (to take out the comments from the ), used in Main.cpp
const int MaxBases = 5; //the size of the array that recognizes different bases (A,U,C,G, and "other"), in Input.h and Loop.h
const int MaxPairs = 11; //the size of the array that recognizes different base pairs used
//(7 non canonical, 3 canonical, and 1 other), in Input.h and Loop.h


struct T_IntList
{
  int Num;
  T_IntList * Next;
};

struct T_stackelem 
{
  int MarkB , MarkP , MarkN , next, prev, nextM, prevM;

  //$next and $prev keep track of the next and the previous elements on the stack
  //nextM and pervM are the same as next and prev with skipping those nodes who have markN&markP&!markB
};

enum LoopType
  {
    stackloop, hairpin, interior, multi, external, pseudo, bulge
  };

enum PseudoNestedType
  {
    nothing, inBand, unBand, inMulti
  };


struct T_AllLoops
{

  int base1, base2;

};


//For Bands
struct B_pattern 
{
  bool BandBorder; // if it was recognized to be a band border
  int next, prev; // next and prev elements in the pattern , right now ( later might be *)
  // we might need int index
  int OtherBorder; // itself would be the forst border of band-region (e.g i or j') and
  // OtherBorder will be the second border of band-region (e.g. i' or j)
};

////////////////////// added from Mirela/structs.h

  typedef struct str_features
  {
  short int pair;
  char type;                   // type can be 'H', 'S', 'I', 'M'
  short int num_branches;
  short int pseudo_num_branches;
  int bri[MAX_BRANCHES];      // the i of each branch

  str_features()
  {
  pair = -1;
  type = NONE;
  num_branches = 0;
  }
  } str_features;


////////////////////////////////
#endif

