#ifndef INPUT_H
#define INPUT_H

#include "Defines.h"
#include <ctype.h>
#include <vector>
#include <iostream>

class Loop;
class LoopList;

using namespace std;

class ReadInput 
{
 private:

 public:


  char CSequence[MaxN];
  int  Sequence[MaxN];
  
  Loop * ClosedRegions[MaxN];			//ClosedRegion[i] is the pointer to the loop starting at i

  int  type[MaxN];			//whether it is  A, C, G, or T(U)
  LoopList *looplists[MaxN];
  str_features loops[MaxN];  //storing loops features such as base pairs ...
  int Size;

  int  Next[MaxN];		//Next paired Base
  int Prev[MaxN];		//Previous paired Base
 
  //added by Vera up to "end" comment
  
  vector<int> to_be_removed;
  int where_at;
  bool not_finished;
  vector<int> bands_to_remove;
  
  /*
  int Enriched[MaxN][2]; //not used right now
  
  string EC1[11]; //not used right now
  string EC2[5]; //not used right now
  */
  
  //avg, max, min stats for stems, bands, hairpin/internal/multi loops and bulges
  int avg_stem, avg_band, avg_h, avg_i, avg_m, avg_b;
  int max_stem, max_band, min_stem, min_band, max_h, min_h;
  int max_i, min_i, max_b, min_b, max_m, min_m;
  int num_length_i, num_length_b, num_length_m;
  
  //this is to keep track of the beginning and ends of pseudoknotted regions
  int left[MaxN]; 
  int right[MaxN];

  //total counts of different loops and such
  int tot_pseudo; //to count the total number of pseudoknots
  int tot_bands;
  
  int tot_stems, tot_hairpins, tot_bulges, tot_inter;
  int tot_multi, tot_external, tot_stacks, tot_domains;

  int tot_pstems, tot_phairpins, tot_pbulges, tot_pinter;
  int tot_pmulti, tot_pstacks;
  
  //this is all for pairs and bases found in pairs
  int tot_bases[MaxBases];
  int tot_pairs[MaxPairs];
  
  int tot_pbases[MaxBases];
  int tot_ppairs[MaxPairs];

  int tot_Bases; //found in stems
  int tot_Pairs;
  
  int tot_pBases;
  int tot_pPairs;

  char basesChar[MaxBases-1]; // {'A','U','C','G'} all the arrays associated with bases will have an additional
  //entry for "other"
  string pairsChar[MaxPairs]; //{"AA","UU","CC","GG","AC","AG","UC","UG","AU","CG", "other base pair"}
                                //0,   1,   2,   3,   4,    5,  6,   7,   8    9      10   
  
  //for free bases found in different loops
  int tot_fbh, tot_fbi, tot_fbb, tot_fbm, tot_fbe, tot_fbpl, tot_fbwb;
  
  int fbh[MaxBases], fbi[MaxBases], fbb[MaxBases], fbm[MaxBases], fbe[MaxBases];
  int fbpl[MaxBases]; //for pseudo loops
  int fbwb[MaxBases]; //for those within bands
  
  //for closing base pairs of different loops and such
  int cbph[MaxPairs], cbpi[MaxPairs], cbpb[MaxPairs], cbpm[MaxPairs], cbpe[MaxPairs];
  
  int tot_cbph, tot_cbpi, tot_cbpb, tot_cbpm, tot_cbpe;
  
  //end

  void	AddPair(int m, int n, char c);				// pair[m] = n and type[m] = c
  ReadInput(char* fseq, char* fbpseq);						//Constructor
  ReadInput(int n, vector <int> sequence, vector <char> csequence, vector <int> to_remove);
  ReadInput(int size, const unsigned char* baseSequence, const unsigned short* pairRefSequence);
  ~ReadInput();
  int BasePair(int a);			//The base pair of an element. Is 0 if the element is not paired
};

#endif
