#include "LoopList.h"
#include "Loop.h"

//#define NULL 0


//SSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSS

LoopList::LoopList(ReadInput* R, int b1, int b2)
{
  base1 = b1;
  base2 = b2;
  //cout << "bases: " << base1 <<  " " << base2 << endl;
  Size = 0;
  Input = R;
}

//SSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSS

LoopList::~LoopList()
{
}

//SSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSS

void LoopList::FindChildren()
{
  Input->loops[base1].num_branches = 0;
  Input->loops[base1].pseudo_num_branches = 0;
  int i = Input->Next[base1];
  int j = base2;

  while (i < j)
    {
      if (Input->ClosedRegions[i] != NULL) //check that the pointer to the loop, starting at i is not null
	{
	  //increment num_branches and set the i of bri for that branch
	  Input->loops[base1].bri[Input->loops[base1].num_branches++] = i;
	  //if the type of the ClosedRegion being looked at is pseudo (ie has pseudoknots inside) then
	  if (Input->ClosedRegions[i]->type == pseudo)
	    //the array with each loop's features gets its number of pseudo branches incremented by two, 
	    //as both the bigger region and the loop that we are looking at now are pseudo (thus two pseudo branches)
	    Input->loops[base1].pseudo_num_branches += 2;
	  else
	    //else it is only incremented by 1 (as we only found the child of this loop to be pseudo)
	    Input->loops[base1].pseudo_num_branches += 1;

	  //at last we just to the end of our region
	  i = Input->Next[Input->ClosedRegions[i]->end];
	}

      else
	{
	  //if the pointer was null, then just go to the next base in our input sequence
	  i = Input->Next[i];
	}
    };

  //do basically the same thing but this time traversing from end of the region
  //this is because we have two bands crossing, thus we want to make sure that
  //we have covered all the regions.

  i = Input->Next[Input->BasePair(base2)];
  j = Input->BasePair(base1);

  while (i < j)
    {
      if (Input->ClosedRegions[i] != NULL)
	{
	  Input->loops[base1].bri[Input->loops[base1].num_branches++] = i;

	  if (Input->ClosedRegions[i]->type == pseudo)
	    Input->loops[base1].pseudo_num_branches += 2;

	  else
	    Input->loops[base1].pseudo_num_branches += 1;
   
	  i = Input->Next[Input->ClosedRegions[i]->end];
	}

      else
	{
	  i = Input->Next[i];
	}
    };
};

//SSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSS

void LoopList::FindPseudoChildren(int NumberOfBands, int * bandborders)
{
  Input->loops[base1].num_branches = 0;
  Input->loops[base1].pseudo_num_branches = 0;
  int i = Input->Next[base1];
  int j = base2;

  while (i < j)
    {
      if (Input->ClosedRegions[i] != NULL) //check that the pointer to the loop, starting at i is not null
	{
	  //increment num_branches and set the i of bri for that branch
	  Input->loops[base1].bri[Input->loops[base1].num_branches++] = i;
	  //if the type of the ClosedRegion being looked at is pseudo (ie has pseudoknots inside) then
	  if (Input->ClosedRegions[i]->type == pseudo)
	    //the array with each loop's features gets its number of pseudo branches incremented by two, 
	    //as both the bigger region and the loop that we are looking at now are pseudo (thus two pseudo branches)
	    Input->loops[base1].pseudo_num_branches += 2;
	  else
	    //else it is only incremented by 1 (as we only found the child of this loop to be pseudo)
	    Input->loops[base1].pseudo_num_branches += 1;

	  //at last we just to the end of our region
	  i = Input->Next[Input->ClosedRegions[i]->end];
	}

      else
	{
	  //if the pointer was null, then just go to the next base in our input sequence
	  i = Input->Next[i];
	}
    };

  //do basically the same thing but this time traversing from end of the region
  //this is because we have two bands crossing, thus we want to make sure that
  //we have covered all the regions.

  i = Input->Next[Input->BasePair(base2)];
  j = Input->BasePair(base1);

  while (i < j)
    {
      if (Input->ClosedRegions[i] != NULL)
	{
	  Input->loops[base1].bri[Input->loops[base1].num_branches++] = i;

	  if (Input->ClosedRegions[i]->type == pseudo)
	    Input->loops[base1].pseudo_num_branches += 2;

	  else
	    Input->loops[base1].pseudo_num_branches += 1;

	  i = Input->Next[Input->ClosedRegions[i]->end];
	}

      else
	{
	  i = Input->Next[i];
	}
    };
}


