#include "PlotRna.h"

char* fname;

static void drawInit( int sizex, int sizey, char* filename, char* id) 
{

 int i,k=0;
 int x,y;
 char* c;
 c =(char*)malloc(sizeof(char)*1000);
 
/* initialize display */
 init_graphics("RNA");


/* still picture drawing allows user to zoom, etc. */
 init_world (0.,0.,CELLSIZE*sizex,CELLSIZE*sizey);
 //event_loop(button_press, drawscreen);   

/* animation section */
 clearscreen();
 init_postscript(filename);
 clearscreen();

 sprintf(c, "RNA SSTRAND Molecule ID = %s", id);
 drawtext ((int)sizex*CELLSIZE/5.8,sizey*65,c,1.0e6);
 flushinput(); 
  
 sprintf(c, " Length = %d", sizex);
 //printf(" output string is %s\n",c);
 //update_message("RNA secondary structure");
 //flushinput();
 
 drawtext ((int)sizex*CELLSIZE/12.9,sizey*70,c,1.0e6);
 flushinput();
 
 sprintf(c, " Colors of rectangles correspond to bases at that position: A-Red, U-Green, G-Blue, C-Black, Other-Grey.");
 //printf(" output string is %s\n",c);
 
 drawtext ((int)sizex*CELLSIZE/2.2,sizey*75,c,1.0e6);
 flushinput();
 
 sprintf(c, "  Dashed arcs in magenta form a minimum-size set of arcs whose removal makes the structure pseudoknot-free.");
 //printf(" output string is %s\n",c);
 
 drawtext ((int)sizex*CELLSIZE/2.1,sizey*80,c,1.0e6);
 flushinput();
  
 setcolor (BLACK);
 setlinewidth(1);
 setlinestyle (SOLID);
 for (i=0;i<=sizex;i++) {
    drawline (i*CELLSIZE,(sizey/2-1)*CELLSIZE,i*CELLSIZE,CELLSIZE*sizey/2);
    flushinput();
 }
 drawline(0,(sizey/2-1)*CELLSIZE, sizex*CELLSIZE, CELLSIZE*(sizey/2-1));
 drawline(0,sizey*CELLSIZE/2, sizex*CELLSIZE, CELLSIZE*sizey/2);
 flushinput();
 free(c);
}

void PlotRna(vector<char>& sequence, vector<int>& structure, char* filename, char* id, vector<int>& to_be_removed)
{
  /*A:red, U: Green, G:Blue, C:Yellow*/
  int i, j;
  int length;
  int sizex, sizey;
  
  
  fname = filename;
  length = sequence.size();
  sizex = length;
  sizey = length;

  drawInit(length, length, filename, id);
  
  for(i=0; i<length; i++) {
    if(sequence[i] == 'A' || sequence[i] == 'a') 
      setcolor(RED);
    else if(sequence[i] == 'U'|| sequence[i] == 'u')
      setcolor(GREEN);
    else if(sequence[i] == 'G' || sequence[i] == 'g')
      setcolor(BLUE);
    else if(sequence[i] == 'C' || sequence[i] == 'c')
      setcolor(BLACK);
    else
      setcolor(DARKGREY);
    fillrect((i+0.2)*CELLSIZE, (sizey/2 - 0.8)*CELLSIZE, (i+0.8)*CELLSIZE, (sizey/2 - 0.2)*CELLSIZE);
    double width1 = (i+0.8)*CELLSIZE;
    double width2 = (i+0.2)*CELLSIZE;
    printf("the width: %d-%d\n", width2, width1);
    //printf("the base is %c, while the index is %d, its structure comp: %d\n", sequence[i], i, structure[i]);
    flushinput();
  }
  plotBP(sequence, structure, to_be_removed);
  close_postscript();
  close_graphics();
}

static void plotBP(vector<char>& sequence, vector<int>& structure, vector<int>& to_be_removed)
{
  int i;
  int length;
  float lx, ly;
  float arcx, arcy, rad;
  length = sequence.size();
  int where_at = 0;

  for(i = 0; i<length; i++) 
  {
    setlinestyle(SOLID);
    setcolor(BLACK);
    if(structure[i] > i) //ie open braket
    {
      //check if this arc was supposed to be removed due to MIS calculation, if yes, color it red
      for(int j=where_at; j<to_be_removed.size(); j++)
      {
        if(to_be_removed[j]-1==i) //it is to be removed
        {
          setlinestyle(DASHED);
          setcolor(MAGENTA);
          where_at = j;
          break;
        }
        if(to_be_removed[j]>i)
          break; //already surpassed this arc
      }
      lx = structure[i] - i + 1;
      
      //drawline((i+0.5)*CELLSIZE, length*CELLSIZE/2 - 1, (i + 0.5)*CELLSIZE, (length+lx)*CELLSIZE/2 -1);
      flushinput();
    
      //drawline((structure[i]-0.5)*CELLSIZE, length*CELLSIZE/2-1,(structure[i]-0.5)*CELLSIZE, (length+lx)*CELLSIZE/2 -1);
      flushinput();
      //drawline((i+0.5)*CELLSIZE, (length+lx)*CELLSIZE/2-1, (structure[i]-0.5)*CELLSIZE, (length+lx)*CELLSIZE/2-1);
      arcx = (i + structure[i] )/2.0 * CELLSIZE;
      arcy = (length/2-1)*CELLSIZE;
      rad = (structure[i] - 1 - i )/2.0 * CELLSIZE;
      printf("the rad: %d\n", (structure[i] - 1 - i )/2.0 * CELLSIZE);
      //rad = 10;
      drawarc(arcx, arcy,  rad, 0, 180.0);
      flushinput();
    }
  }
}
      
static void drawscreen(void) 
{
  return;
}

static void button_press (float x, float y) 
{

/* Called whenever event_loop gets a button press in the graphics *
 * area.  Allows the user to do whatever he/she wants with button *
 * clicks.                                                        */

 printf("User clicked a button at coordinates (%f, %f)\n", x, y);
}


 































