#include "clentry.h"

using namespace std;

// default contructor
//PRE: nothing
//POST: initalises rep to -1 and ww to zero
clentry::clentry()
{
  rep=-1;
  ww = 0;
}
       
//constructor
//PRE:	none
//POST: rep and ww are set
clentry::clentry(int r, int w)
{
  rep = r;
  ww = w;
}

//copy constructor
//PRE:	none
//POST:	A new clentry is created with the same
// parameters as original
clentry::clentry(const clentry& original)
{
  copy(original);
}

//Member operator function
//PRE:	none
//POST:	the contents of otherCLEntry are copied into this clentry
const clentry& clentry::operator=(const clentry& otherCLEntry)
{
  if (&otherCLEntry != this)
    {
      copy(otherCLEntry);
    }
  return *this;
}

//destructor
//PRE: a clentry exists
//POST: it is destroyed
clentry::~clentry()
{
}

//make a copy of another clentry
//PRE:	none
//POST:	the contents of the other clentry are 
//		copied into this one
void clentry::copy(const clentry& otherCLEntry)
{
	rep = otherCLEntry.rep;
	ww = otherCLEntry.ww;
}

	
//get rep
//PRE: none
//POST:	rep is returned
int clentry::getREP()
{
  return rep;
}
	
//get ww of clentry
//PRE: none
//POST:	ww returned	
int clentry::getWW()
{
  return ww;
}
	
//set rep of clentry
//PRE: none
//POST:	rep of the clentry is set
void clentry::setREP(int r)
{
  rep = r;
}
	
//set ww 
//PRE:	none
//POST:	ww is set to w
void clentry::setWW(int w)
{
  ww = w;
}

  //for debugging purposes
  void clentry::print_it()
{
  cout << "r: " << rep << ", ww: " << ww;
}
