#ifndef CLENTRY_H
#define CLENTRY_H

#include <iostream>
#include <stdlib.h>
#include <stdio.h>
#include <string.h>

class clentry 
{	
 public:

  // default contructor
  //PRE: nothing
  //POST: initalises rep to -1 and ww to zero
  clentry();
	
  //constructor
  //PRE:	none
  //POST: rep and ww are set
  clentry(int rep, int ww);

  //copy constructor
  //PRE:	none
  //POST:	A new clentry is created with the same
  // parameters as original
  clentry(const clentry& original);

  //destructor
  //PRE: a clentry exists
  //POST: it is destroyed
  ~clentry();

  //Member operator function
  //PRE:	none
  //POST:	the contents of otherCLEntry are copied into this clentry
  const clentry& operator=(const clentry& otherCLEntry);
	
  //get rep
  //PRE: none
  //POST:	rep is returned
  int getREP();
	
  //get ww of clentry
  //PRE: none
  //POST:	ww returned	
  int getWW();
	
  //set rep of clentry
  //PRE: none
  //POST:	rep of the clentry is set
  void setREP(int r);
	
  //set ww 
  //PRE:	none
  //POST:	ww is set to w
  void setWW(int w);

  //for debugging purposes
  void print_it();


 private:

  //make a copy of another clentry
  //PRE:	none
  //POST:	the contents of the other clentry are 
  //		copied into this one
  void copy(const clentry& otherCLEntry);

  int rep; // stands for right hand point
  int ww; // specially calculated weight
};

#endif
