#include "interval.h"

using namespace std;

// default contructor
//PRE: nothing
//POST: initalises r,l and i to -1
interval::interval()
{
  r=l=i=-1;
}
	
//constructor
//PRE: none
//POST: r,l and i are set
interval::interval(int right, int left, int interval)
{
  r=right;
  l=left;
  i = interval;
}

//copy constructor
//PRE: none
//POST: A new interval is created with the same
// parameters as original
interval::interval(const interval& original)
{
  copy(original);
}

//destructor
//PRE: an interval exists
//POST: it is destroyed
interval::~interval()
{
}

//Member operator function
//PRE: none
//POST: the contents of otherInterval are copied into this interval
const interval::interval& interval::operator=(const interval::interval& otherInterval)
{
  if (&otherInterval != this)
    {
      copy(otherInterval);
    }
  return *this;
}
	
//get r
//PRE: none
//POST: r is returned
int interval::getR()
{
  return r;
}

//get l
//PRE: none
//POST: l is returned
int interval::getL()
{
  return l;
}

//get i
//PRE: none
//POST: i is returned
int interval::getI()
{
  return i;
}
	
//set r 
//PRE: none
//POST: r is set to right
void interval::setR(int right)
{
  r = right;
}

//set l 
//PRE: none
//POST: l is set to left
void interval::setL(int left)
{
  l = left;
}

//set i 
//PRE: none
//POST: i is set to inter
void interval::setI(int inter)
{
  i = inter;
}

//for debugging purposes
void interval::print_interval()
{
  cout << "r: " << r << ", l: " << l << ", i: " << i << endl;
}

//make a copy of another interval
//PRE: none
//POST: the contents of the other interval are 
// copied into this one
void interval::copy(const interval& otherInterval)
{

  r = otherInterval.r;
  l = otherInterval.l;
  i = otherInterval.i;
}

