#ifndef INTERVAL_H
#define INTERVAL_H

#include <iostream>
#include <stdlib.h>
#include <stdio.h>
#include <string.h>

class interval
{	
 public:

  // default contructor
  //PRE: nothing
  //POST: 
  interval();
	
  //constructor
  //PRE:	none
  //POST: r,l and i are set
  interval(int right, int left, int interval);

  //copy constructor
  //PRE: none
  //POST: A new interval is created with the same
  // parameters as original
  interval(const interval& original);

  //destructor
  //PRE: an interval exists
  //POST: it is destroyed
  ~interval();

  //Member operator function
  //PRE: none
  //POST: the contents of otherInterval are copied into this interval
  const interval& operator=(const interval& otherInterval);
	
  //get r
  //PRE: none
  //POST: r is returned
  int getR();

  //get l
  //PRE: none
  //POST: l is returned
  int getL();

  //get i
  //PRE: none
  //POST: i is returned
  int getI();
	
  //set r 
  //PRE: none
  //POST: r is set to right
  void setR(int right);

  //set l 
  //PRE: none
  //POST: l is set to left
  void setL(int left);

  //set i 
  //PRE: none
  //POST: i is set to inter
  void setI(int inter);

  //for debugging purposes
  void print_interval();


 private:

  //make a copy of another interval
  //PRE: none
  //POST: the contents of the other interval are 
  // copied into this one
  void copy(const interval& otherInterval);

  int r; // right end point
  int l; // left end point
  int i; // interval
};

#endif
