#ifndef OENTRY_H
#define OENTRY_H

#include <iostream>
#include <stdlib.h>
#include <stdio.h>
#include <string>
#include <list>
#include <cstdlib>



#include "clentry.h"


using namespace std;

class oentry 
{	
 public:

  // default contructor
  //PRE: nothing
  //POST: initalizes i to -1
  oentry();

  //another constructor
  //PRE: given i
  //POST: initalizes i to pos
  oentry(int pos);

  //copy constructor
  //PRE:	none
  //POST:	A new clentry is created with the same
  // parameters as original
  oentry(const oentry& original);

  //destructor
  //PRE: a clentry exists
  //POST: it is destroyed
  ~oentry();

  //Member operator function
  //PRE:	none
  //POST:	the contents of otherCLEntry are copied into this clentry
  const oentry& operator=(const oentry& otherOEntry);

  //the comparison operator needs to be overloaded
  bool operator== (const oentry& right) const;

	
  //get rep
  //PRE: none
  //POST:	rep is returned
  int getI();

  //get an iterator to the clist
  //PRE: none
  //POST: iterator to the clist is returned
  list<clentry>::iterator getCLIST_IT();
	

  //to check if we have traversed to the end of our clist
  //PRE:none
  //POST: returns iterator at the end of clist
  list<clentry>::iterator at_end();

  //to push something onto the clist
  //PRE:given clentry
  //POST: clentry is pushed onto clist
  void push_cl(const clentry& cl);
	
  //for debugging purposes, prints oentry
  void print();
  
  //check if clist is empty
  bool empty();


 private:

  //make a copy of another clentry
  //PRE:	none
  //POST:	the contents of the other clentry are 
  //		copied into this one
  void copy(const oentry& otherOEntry);

  int i; // stands for the position of the open braket of the interval 
  // this braket will be pushed onto an Open list, hence the weired name: oentry

  list<clentry> clist; // list that contains clentries

};

#endif
